#include "main.h"
#include <string.h>

static Scene *scn;

int main(int argc, char **argv)
{
  Scene *s;

  init_lang();
  scn = scene_read();

  init_glut("igl", scn);
  set_render_to_fbo_gl(TRUE);
  
  setup_scene_gl(scn);
  load_objects_gl(scn->objs);
  display_gl(scn);
  close_gl(scn);
  
  img_write(scn->img, "stdout", 0);
  exit(0);
}

// ------------------------------

void init_glut(char *name, Scene *s)
{
  int ac = 0; char *av[1] = {""};
  glutInit(&ac, av);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
  glutInitWindowSize(s->img->w, s->img->h);
  glutCreateWindow(name);
}

// ------------------------------

void init_lang(void)
{
  lang_defun("scene", scene_parse);
  lang_defun("view", view_parse);
  lang_defun("dist_light", distlight_parse);
  lang_defun("plastic", plastic_parse);

  lang_defun("shaderprog", shaderprog_parse);

  lang_defun("meshobj", obj_parse);
  lang_defun("mesh", imesh_parse);

  lang_defun("primobj", obj_parse);
  lang_defun("sphere", sphere_parse);

  lang_defun("group", graph_parse);
  lang_defun("affine", xaffine_parse);

  lang_defun("slideproj", slideproj_parse);
  lang_defun("shiny", shiny_parse);
  lang_defun("rough", rough_parse);
  lang_defun("textured", textured_parse);
  lang_defun("imagemap", imagemap_parse);
  lang_defun("chequer", chequer_parse);

  lang_defun("arg", arg_parse);
  lang_defun("motor", motor_parse);

  lang_defun("include", include_parse);
}

