#ifndef PLOT_H
#define PLOT_H

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>

#ifdef __APPLE__
#include <OpenGL/gl.h>
#include <GLUT/glut.h>
#else
#include <GL/gl.h>
#include <GL/glut.h>
#endif

#include "image.h"
#include "defs.h"
#include "geom.h"
#include "stack.h"
#include "view.h"
#include "poly.h"
#include "prim.h"
#include "hier.h"
#include "lang.h"
#include "clip.h"
#include "raster.h"
#include "shade.h"
#include "map.h"
#include "anim.h"

#include "zbuf.h"
#include "scene.h"
#include "opengl.h"

// -------------------------------------------

void init_lang(void);

// --------------------------------------------

int render_scene(Scene *s);

void init_render(Scene *s);
iMesh *tesselate(Object *obj);
Hpoly *assembly(Object *obj, iTri *t);
int vertex_proc(Hpoly *p, void *d, Object *obj);
void plot_hpoly(Hpoly *p);
void close_render(void);

// --------------------------------------------

void dvflush(void);
void dvclear(double c);
void dvcolor(double c);
void dvwindow(double xmax, double ymax);
void dvplot(double x1, double y1);
void dvline(double x1, double y1, double x2, double y2);
double dv_map_y(double y);

#endif // PLOT_H
