#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>

#include "image.h"
#include "color.h"
#include "defs.h"
#include "geom.h"
#include "stack.h"
#include "view.h"
#include "poly.h"
#include "prim.h"
#include "hier.h"
#include "lang.h"
#include "clip.h"
#include "raster.h"
#include "shade.h"
#include "map.h"
#include "anim.h"
#include "scene.h"
#include "obj.h"
#include "zbuf.h"

void init_lang(void);
void init_render(Scene *s);
iMesh *tesselate(Object *obj);
Hpoly *assembly(Object *obj, iTri *t);
int vertex_proc(Hpoly *p, void *d, Object *obj);
void pixel_proc(Vector4 v,int n,int lv,Real lt,int rv,Real rt,Real st,void *c);
void raster_proc(Scene *s);

Hpoly *prim_polys(Prim *s, iTri *t);
Hpoly *mesh_polys(iMesh *m, iTri *t);

void shade_dummy(int i);

#define M(o) (o->mat)



#ifdef FLAT_SHADE
#define SHADE_DATA FlatData
#define SHADE_NPOLYS 1, 3
#define SHADE_PREP flat_setshade
#define SHADE_PREP_PARAMS (FlatData *)d, PL(p), s->view->center, rc, M(obj)
#define SHADE_SET 
#define SHADE_SET_PARAMS d
#define SHADE_PAINT flat_paint
#define PL(l) (l)
#define TAIL(l) (l->next)
#endif

#ifdef GOURAUD_SHADE
#define SHADE_DATA GouraudData
#define SHADE_NPOLYS 3, 3
#define SHADE_PREP gouraud_shade
#define SHADE_PREP_PARAMS CL(p), PL(p), NL(p), s->view->center, rc, M(obj)
#define SHADE_SET gouraud_set
#define SHADE_SET_PARAMS  (GouraudData *)d, CL(p), s->img
#define SHADE_PAINT gouraud_paint
#define PL(l) (l)
#define NL(l) (l->next)
#define CL(l) (l->next->next)
#define TAIL(l) (l->next->next->next)
#endif

#ifdef PHONG_SHADE
#define SHADE_DATA PhongData
#define SHADE_NPOLYS 3, 3
#define SHADE_PREP shade_dummy
#define SHADE_PREP_PARAMS 0
#define SHADE_SET phong_set
#define SHADE_SET_PARAMS  (PhongData *)d, PL(p), NL(p), s->view->center, rc, M(obj)
#define SHADE_PAINT phong_shadepaint
#define SL(l) (l)
#define PL(l) (l->next)
#define NL(l) (l->next->next)
#define TAIL(l) (l->next->next->next)
#endif

#ifdef MAP_SHADE
#define SHADE_DATA TextureData
#define SHADE_NPOLYS 7, 3
#define SHADE_PREP shade_dummy
#define SHADE_PREP_PARAMS 0
#define SHADE_SET texture_set
#define SHADE_SET_PARAMS  (TextureData *)d,WL(p),TL(p),PL(p),NL(p),DUL(p),DVL(p),rc,M(obj)
#define SHADE_PAINT texture_shadepaint
#define SL(l) (l)
#define WL(l) (l->next)
#define TL(l) (l->next->next)
#define PL(l) (l->next->next->next)
#define NL(l) (l->next->next->next->next)
#define DUL(l) (l->next->next->next->next->next)
#define DVL(l) (l->next->next->next->next->next->next)
#define TAIL(l) (l->next->next->next->next->next->next->next)
#endif





