
#include <QtWidgets>
#include "imageviewer.h"


ImageViewer::ImageViewer(QString fname, float scalefac)
{
    imageLabel = new QLabel;
    imageLabel->setScaledContents(true);

    setCentralWidget(imageLabel);
    setWindowTitle(fname);

    fileName = fname;
    scaleFactor = scalefac;

    open();
}

void ImageViewer::keyPressEvent(QKeyEvent *evt)
{
    if(evt->key() == Qt::Key_Q)
        QCoreApplication::quit();
}


void ImageViewer::open()
{
    if (!fileName.isEmpty()) {
        QImage image(fileName);
        if (image.isNull()) {
            QMessageBox::information(this, tr("Image Viewer"), tr("Cannot load %1.").arg(fileName));
	    exit(0);
        }
        imageLabel->setPixmap(QPixmap::fromImage(image));
        resize(image.size()*scaleFactor);
    }
}


