#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>

#include "image.h"
#include "defs.h"
#include "geom.h"
#include "stack.h"
#include "view.h"
#include "poly.h"
#include "prim.h"
#include "hier.h"
#include "lang.h"
#include "clip.h"
#include "raster.h"
#include "shade.h"
#include "scene.h"
#include "obj.h"
#include "zsort.h"

#define GOURAUD_SHADE
#ifdef GOURAUD_SHADE
#define SHADE_DATA GouraudData
#define SHADE_NPOLYS 3, 3
#define SHADE_PREP gouraud_shade
#define SHADE_PREP_PARAMS C(i), P(i), N(i), s->view->center, rc, M(i)
#define SHADE_SET gouraud_set
#define SHADE_SET_PARAMS  (GouraudData *)vdata, C(i), s->img
#define SHADE_PAINT gouraud_paint
#define PL(l) (l)
#define NL(l) (l->next)
#define CL(l) (l->next->next)
#define TAIL(l) (l->next->next->next)
#define P(I) (((Zdatum *)(I->d))->l)
#define N(I) (((Zdatum *)(I->d))->l->next)
#define C(I) (((Zdatum *)(I->d))->l->next->next)
#endif

#define M(I) (((Zdatum *)(I->d))->o->mat)

void init_lang(void);
void init_render(void);

void z_store(Hpoly *l);

iMesh *tesselate(Object *obj);
Hpoly *assembly(Object *obj, iTri *t);
int vertex_proc_cull(Hpoly *p, void *d, Object *obj);
Hpoly *vertex_proc_shade(Hpoly *p, void *d, Item *i);
void pixel_proc(Vector4 v,int n,int lv,Real lt,int rv,Real rt,Real st,void *c);
void raster_proc(Scene *s);

Hpoly *prim_polys(Prim *s, iTri *t);
Hpoly *mesh_polys(iMesh *m, iTri *t);





